

#include "minigui.ch"

#define PRODUCTID "KPI"
#define PRODUCTNM "Dashboard"
#define CLIENT    ""
#define VERSIONID 1.0
#define HOMEPAGE  ""
#define SERVERADD ""
#DEFINE FILLER    SPACE(3)

#define FALSE .F.
#define TRUE  .T.

REQUEST DBFCDX, DBFFPT


***************
function Main()

Local aSer:={ {14280,20420,12870,25347, 7640},;
           { 8350,10315,15870, 5347,12340},;
           {12345, -8945,10560,15600,17610} }
           
   *--> control flag to monitor windows minimize and restore events
   PRIVATE lWndMin   := FALSE
   
   *--> control flag to monitor windows maximize and restore events
   PRIVATE lWndSize   := FALSE   
   
   ANNOUNCE RDDSYS
   SET FIXED ON 
   SET DECIMALS TO 2
   SET MULTIPLE OFF WARNING
   SET DATE AMERICAN
   SET CENTURY ON
   SET EPOCH TO 1950
   SET WRAP ON
   SET SCOREBOARD OFF
   SET DELETED ON
   SET CONFIRM ON
   SET BELL ON
   SET FONT TO "Verdana" , 9
   SET NAVIGATION EXTENDED
   SET BROWSESYNC ON
   SET TOOLTIPSTYLE BALLOON
   SET TOOLTIPBACKCOLOR { 255 , 255 , 255 }
   SET TOOLTIPFORECOLOR { 0 , 0 , 0 }
   RDDSETDEFAULT("DBFCDX")
   
   DEFINE WINDOW MainForm ;
      AT 0,0 ;
      WIDTH 640 HEIGHT 480 ;
      TITLE PRODUCTNM + " Version " + ALLTRIM( STR( VERSIONID ) ) ;
      MAIN ;
      ICON "graph.ico" ;
      NOTIFYICON "graph.ico" ;
      NOTIFYTOOLTIP PRODUCTNM ;
      ON INIT ( ShowDashboard(), DrawBarGraph( aser ) ) ;
      ON MINIMIZE ShowDashboard() ;
      ON MAXIMIZE Resize( TRUE ) ;
      ON SIZE Resize( FALSE ) ;
      ON NOTIFYCLICK ShowDashboard() ;
      ON INTERACTIVECLOSE ForceClose()
   
      DEFINE NOTIFY MENU 
         ITEM "About..."   ACTION MULTIMESSAGE("Dashboard", "About")
         SEPARATOR
         ITEM 'Exit Dashboard' ACTION MainForm.Release
      END MENU
      
      @ GetDesktopHeight() - 110, 0 LABEL Dummy OF MainForm VALUE "" HEIGHT 40 WIDTH GetDesktopWidth();
         FONT "ARIAL" SIZE 10 BACKCOLOR RED FONTCOLOR YELLOW      
      
      @ GetDesktopHeight() - 100, 0 LABEL lblCritical OF MainForm VALUE "Critical" HEIGHT 20 WIDTH GetDesktopWidth();
         FONT "ARIAL" SIZE 10 BACKCOLOR RED FONTCOLOR YELLOW
      
   END WINDOW
   
   
   MainForm.Center()
   MainForm.Activate()
   RELEASE ALL
   RETURN NIL   



Procedure DrawBarGraph ( aSer )

	ERASE WINDOW MainForm

	DRAW GRAPH							;
		IN WINDOW MainForm					;
		AT 20,20						;
		TO 400,610						;
		TITLE "Sales and Product"				;
		TYPE BARS						;
		SERIES aSer						;
		YVALUES {"Mon","Tue","Wed","Thu","Friday"}			;
		DEPTH 15						;
		BARWIDTH 15						;
		HVALUES 5						;
		SERIENAMES {"PRODUCT A","SHAMPOO B","PRODUCT K"}		;
		COLORS { {128,128,255}, {255,102, 10}, {55,201, 48} }	;
		3DVIEW    						;
		SHOWGRID                        			;
		SHOWXVALUES                     			;
		SHOWYVALUES                     			;
		SHOWLEGENDS 						;
		NOBORDER
		
   Return



****************************
static function ForceClose()

   LOCAL lRetVal := FALSE

   lRetVal := MSGYESNO( "Exit Dashboard?", "Please confirm" )
   IF lRetVal
      MainForm.Release()
      DestroyWindow()
   ENDIF
   RETURN lRetval





*******************************
static function DestroyWindow()

   DBCLOSEALL()
   RELEASE WINDOW ALL
   RETURN



*************************************
static function Resize( lMaxMinSize )

   LOCAL nDeskTopWidth  := GETDESKTOPWIDTH()
   LOCAL nDeskTopHeight := GETDESKTOPHEIGHT()
   
   IF lMaxMinSize
      **--> Windows Maximize event

   ELSE
      **--> Windows Minimize event
         
   ENDIF
   RETURN NIL   





*********************************
static function ShowDashboard()

   STATIC nRunOnce := 0

   IF lWndMin
      lWndMin := FALSE
      MainForm.Restore()
      ScrollLabel(FALSE)
   ELSE
      lWndMin := TRUE
      MainForm.Hide()
      ScrollLabel(TRUE)
   ENDIF
   
   RETURN NIL



**************************************
static function ScrollLabel(lExit)


   LOCAL nRow := GetDesktopHeight() - 100
   LOCAL nCol := GetDesktopWidth()
   LOCAL ii := nCol
   LOCAL cText := "PRODUCT A (10/200) -- SHAMPOO B (3/100) -- PRODUCT K (13/20)"
   LOCAL cShowThis := ""

   LOCAL nCharCount := 0
   LOCAL nCharPos   := 1
   
   LOCAL nWidth := 0

   nCharCount := len( cText )

   WHILE TRUE
      if lExit
         EXIT
      endif
      
      if ii < 0
      
         if len( MainForm.lblCritical.Value ) = 1
            MainForm.lblCritical.Value := ""
            MainForm.lblCritical.Width := 0
            nCharPos  := 1
            cShowThis := ""
            ii        := nCol
         else
            MainForm.lblCritical.Hide
            cShowThis := alltrim( substr( MainForm.lblCritical.Value, 2 ) )
            nWidth    := GetTextWidth( nil, cShowThis, "Arial" )
            MainForm.lblCritical.Width := nWidth
            MainForm.lblCritical.Value := cShowThis
            MainForm.lblCritical.Show
            Delay( 700000 )
         endif      
      
      else
         cShowThis += substr( cText, ( nCharPos++ ), 1 )
         nWidth    := GetTextWidth( nil, cShowThis, "Arial" )
         ** MainForm.lblCritical.Hide
         MainForm.lblCritical.Col   := ii
         MainForm.lblCritical.Width := nWidth
         MainForm.lblCritical.Value := cShowThis
         ** MainForm.lblCritical.Show
         ii--
         Delay()
      endif
      do events
   
   END
   RETURN


   
*****************************
static function Delay(nDelay)

   LOCAL nIterate := 0
   
   IF VALTYPE( nDelay ) == "U"; nDelay := 190000; endif
   WHILE nIterate++ < nDelay; END; nIterate := 0
   RETURN nil








* La DALE-Aid Creative Solutions Standard Function Header Comment Template
*_.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.*

********************************************************************************
**  Function:                                                                 **
**   Purpose:                                                                 **
**                                                                            **
**    Syntax:                                                                 **
**                                                                            **
** Arguments:                                                                 **
**                                                                            **
**   Returns:                                                                 **
**                                                                            **
**     Notes:                                                                 **
********************************************************************************

********************************************************************************
**  Function:                                                                 **
**   Purpose:                                                                 **
**                                                                            **
** Called By:                                                                 **
**                                                                            **
**    Syntax:                                                                 **
**                                                                            **
** Arguments:                                                                 **
**                                                                            **
**   Returns:                                                                 **
**                                                                            **
**     Notes:                                                                 **
********************************************************************************


********************************************************************************
**    Class Name:                                                             **
**       Purpose:                                                             **
**                                                                            **
** Exported Data:                                                             **
**   Hidden Data:                                                             **
**       Methods:                                                             **
**                                                                            **
**        Syntax:                                                             **
**                                                                            **
**     Arguments:                                                             **
**                                                                            **
**       Returns:                                                             **
**                                                                            **
**       Example:                                                             **
**                                                                            **
**         Notes:                                                             **
********************************************************************************

********************************************************************************
**   Method Name:                                                             **
**       Purpose:                                                             **
**                                                                            **
**        Syntax:                                                             **
**                                                                            **
**     Arguments:                                                             **
**                                                                            **
**       Returns:                                                             **
**                                                                            **
**       Example:                                                             **
**                                                                            **
**         Notes:                                                             **
********************************************************************************


*-._.--._.--._.--._.--._.--._.--._.--._.--._.--._.--._.--._.--._.--._.--._.--._*
* La DALE-Aid Creative Solutions Standard Program Header Template
*_.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.*

/************************************************************************************ 
 * Program Name....: 
 * Purpose ........: 
 * System Name.....:
 * Client..........:
 *
 * Syntax..........: Harbour + HMG MiniGUI + MinGW32
 *
 * Author..........: Danny A. del Pilar
 * E-mail..........: dhaine_adp@yahoo.com
 * Note............: Copyright  2008 Danny A. del Pilar, All Rights Reserved.
 *                   La DALE-Aid Creative Solutions, Philippines
 *
 * Date Created....: 
 * Last Updated....:
 *  
 * 
 * Revision History: 
 * -----------------
 *
 *
 *****************************************************************************************
*/